#include "Parsodus/lrtables/LR0Itemset.h"

#include <iostream> ///TODO remove me

namespace pds {
namespace lr {

void LR0Itemset::print() const {
    for (auto& item : m_items) {
        std::cout << item.rule->head << " -> ";
        for (std::size_t i = 0; i < item.rule->tail.size(); i++) {
            if (i == item.dotIdx)
                std::cout << " ·";
            std::cout << " " << item.rule->tail[i];
        }
        if (item.dotIdx == item.rule->tail.size()) 
            std::cout << " ·";
        std::cout << std::endl;
    }
}

LR0Itemset::LR0Itemset() : LR0ItemsetBase<LR0Itemset>()
{}

LR0Itemset::LR0Itemset(std::shared_ptr<Rule> start) : LR0ItemsetBase<LR0Itemset>(start)
{}

bool LR0Itemset::needsFollow() {
    return false;
}


std::set<std::size_t> LR0Itemset::getReduces(const Grammar& g, std::string) const {
    std::set<std::size_t> res;
    for (auto& item : m_items) {
        if (item.dotIdx >= item.rule->tail.size()) {
            res.insert(std::find(g.rules.begin(), g.rules.end(), item.rule) - g.rules.begin());
        }
    }
    return res;
}

} /* lr  */ 
} /* pds  */ 
